/*
 * Copyright 2012-2016 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package testapi.server;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import testapi.server.model.NumberValue;

@Controller
public class WelcomeController {

	@GetMapping("/")
	public String welcome(Model model) {
		return "index";
	}

	@RequestMapping("/square/{number}")
	@ResponseBody
	public NumberValue test(@PathVariable int number, Model model) {
		NumberValue numberValue = new NumberValue();

		numberValue.setSquared(number * number);

		return numberValue;
	}
}
